
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_chemical_usagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_chemical_usages = await db.job_chemical_usages.create(
            {
                id: data.id || undefined,
        
        quantity_used: data.quantity_used
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_chemical_usages.setJob_log( data.job_log || null, {
            transaction,
        });
        
        await job_chemical_usages.setChemical_product( data.chemical_product || null, {
            transaction,
        });
        

        

        

        return job_chemical_usages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_chemical_usagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity_used: item.quantity_used
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_chemical_usages = await db.job_chemical_usages.bulkCreate(job_chemical_usagesData, { transaction });

        // For each item created, replace relation files
        

        return job_chemical_usages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const job_chemical_usages = await db.job_chemical_usages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity_used !== undefined) updatePayload.quantity_used = data.quantity_used;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_chemical_usages.update(updatePayload, {transaction});

        
        
        if (data.job_log !== undefined) {
            await job_chemical_usages.setJob_log(
              
              data.job_log,
              
              { transaction }
            );
        }
        
        if (data.chemical_product !== undefined) {
            await job_chemical_usages.setChemical_product(
              
              data.chemical_product,
              
              { transaction }
            );
        }
        

        
        

        

        return job_chemical_usages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_chemical_usages = await db.job_chemical_usages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_chemical_usages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_chemical_usages) {
                await record.destroy({transaction});
            }
        });


        return job_chemical_usages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_chemical_usages = await db.job_chemical_usages.findByPk(id, options);

        await job_chemical_usages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_chemical_usages.destroy({
            transaction
        });

        return job_chemical_usages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_chemical_usages = await db.job_chemical_usages.findOne(
            { where },
            { transaction },
        );

        if (!job_chemical_usages) {
            return job_chemical_usages;
        }

        const output = job_chemical_usages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.job_log = await job_chemical_usages.getJob_log({
            transaction
        });
        
        
        output.chemical_product = await job_chemical_usages.getChemical_product({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.job_logs,
        as: 'job_log',
        
        where: filter.job_log ? {
          [Op.or]: [
            { id: { [Op.in]: filter.job_log.split('|').map(term => Utils.uuid(term)) } },
            {
              job_address: {
                [Op.or]: filter.job_log.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : undefined,
        
      },

      {
        model: db.chemical_products,
        as: 'chemical_product',
        
        where: filter.chemical_product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.chemical_product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.chemical_product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : undefined,
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_chemical_usages',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_usedRange) {
                const [start, end] = filter.quantity_usedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_used: {
                    ...where.quantity_used,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_used: {
                    ...where.quantity_used,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_chemical_usages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_chemical_usages',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_chemical_usages.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

